# Beycan KAHRAMAN - 040020337 - 29.04.2007
# diff - ADVANCED PROGRAMMING - Python 

import sys
import string

class differ:
    
    def __init__(self, argv): # initialization - get parameters & read files
        many = len(sys.argv)
        self.parameters = [False, False, False, False]
        self.file_1 = []
        self.file_2 = []
        self.file_org1 = []
        self.file_org2 = []
        self.errorStart1 = []
        self.errorStart2 = []
        self.errorEnd1 = []
        self.errorEnd2 = []
        self.errorType = []
        if many < 2:
            print 'USAGE: program file1 file2 [parameters]'
            sys.exit(1)
            
        file1 = sys.argv[1]
        file2 = sys.argv[2]
        
        if many > 2:
            for arg in sys.argv: # i w c u
                if arg == '-i':
                    self.parameters[0] = True
                if arg == '-w':
                    self.parameters[1] = True
                if arg == '-u':
                    self.parameters[2] = True
                if arg == '-c':
                    self.parameters[3] = True
            
            if self.parameters[2] and self.parameters[3]:
                print 'confusing parameters ( -c & -u )'
                sys.exit(2)
                
        f = open(file1)
        self.file_org1 = f.read().splitlines()
        
        f = open(file2)
        self.file_org2 = f.read().splitlines()
        
        def controller(c):
            if self.parameters[0]: 
                c = string.lower(c) 
            if self.parameters[1]: 
                c = ' '.join(c.split())
            return c
        
        self.file_1 = [''.join(controller(c)) for c in self.file_org1]
        self.file_2 = [''.join(controller(c)) for c in self.file_org2]
        
    def diff(self): # do the job - calculate diff result
        i = 0
        j = 0
        while i < len(self.file_1) and j < len(self.file_2):
            if self.file_1[i] != self.file_2[j]:
                ii = i
                jj = j
                if(i == len(self.file_1) - 1):
                    i = i+1
                    break;
                if(j == len(self.file_2) - 1):
                    j = j+1
                    break;
                self.errorStart1.append(i)
                self.errorStart2.append(j)
                while ii < len(self.file_1) and jj < len(self.file_2):
                    if self.file_1[ii] == self.file_2[jj]:
                        self.errorEnd1.append(ii)
                        self.errorEnd2.append(jj)
                        if i == ii:
                            self.errorType.append('a')
                        elif j == jj:
                            self.errorType.append('d')
                        else:
                            self.errorType.append('c')
                        i = ii
                        j = jj
                        ii = len(self.file_1)
                        break
                    jj = jj + 1
                    if jj == len(self.file_2):
                        jj = j
                        ii = ii + 1
                    if ii == len(self.file_1) -1 and jj == len(self.file_2)-1:
                        self.errorEnd1.append(ii)
                        self.errorEnd2.append(jj)
                        if i == ii:
                            self.errorType.append('a')
                        elif j == jj:
                            self.errorType.append('d')
                        else:
                            self.errorType.append('c')
                        i = ii
                        j = jj
                        break
            else:
                i = i+1
                j = j+1
        if i < len(self.file_1):
            self.errorStart1.append(i)
            self.errorEnd1.append(len(self.file_1))
            self.errorStart2.append(j)
            self.errorEnd2.append(j)
            self.errorType.append('d')
        elif j < len(self.file_2):
            self.errorStart1.append(i)
            self.errorEnd1.append(i)
            self.errorStart2.append(j)
            self.errorEnd2.append(len(self.file_2))
            self.errorType.append('a')
        
    def printDIFF(self): #print diff result
        if self.parameters[2]:
            errorNo = 0
            i = 0
            while i < len(self.file_org1):
                if errorNo < len(self.errorStart1) and i == self.errorStart1[errorNo]:
                    while self.errorStart1[errorNo] < self.errorEnd1[errorNo]:
                        print self.errorStart1[errorNo]+1, '-\t', self.file_org1[self.errorStart1[errorNo]]
                        self.errorStart1[errorNo] = self.errorStart1[errorNo] + 1
                    while self.errorStart2[errorNo] < self.errorEnd2[errorNo]:
                        print self.errorStart2[errorNo]+1, '+\t', self.file_org2[self.errorStart2[errorNo]]
                        self.errorStart2[errorNo] = self.errorStart2[errorNo] + 1
                    i = self.errorEnd1[errorNo]-1
                    errorNo = errorNo + 1
                else:
                    print i+1, ' \t', self.file_org1[i]
                i = i+1
            if errorNo < len(self.errorStart2):
                while self.errorStart2[errorNo] < self.errorEnd2[errorNo]:
                    print self.errorStart2[errorNo]+1, '+\t', self.file_org2[self.errorStart2[errorNo]]
                    self.errorStart2[errorNo] = self.errorStart2[errorNo] + 1
        elif self.parameters[3]:
            errorNo = 0
            i = 0
            while i < len(self.file_org1):
                if errorNo < len(self.errorStart1) and i == self.errorStart1[errorNo]:
                    change = False
                    while self.errorStart1[errorNo] < self.errorEnd1[errorNo]:
                        if self.errorType[errorNo] == 'c':
                            print self.errorStart1[errorNo]+1, '!\t', self.file_org1[self.errorStart1[errorNo]]
                        else:
                            print self.errorStart1[errorNo]+1, '<\t', self.file_org1[self.errorStart1[errorNo]]
                        self.errorStart1[errorNo] = self.errorStart1[errorNo] + 1
                        change = True
                    if change == True:
                        i = self.errorEnd1[errorNo]-1
                    else: 
                        print i+1, ' \t', self.file_org1[i]
                    errorNo = errorNo + 1
                else:
                    print i+1, ' \t', self.file_org1[i]
                i = i+1
            print '---------------------------------------------------'
            errorNo = 0
            i = 0
            while i < len(self.file_org2):
                if errorNo < len(self.errorStart2) and i == self.errorStart2[errorNo]:
                    change = False
                    while self.errorStart2[errorNo] < self.errorEnd2[errorNo]:
                        if self.errorType[errorNo] == 'c':
                            print self.errorStart2[errorNo]+1, '!\t', self.file_org2[self.errorStart2[errorNo]]
                        else:
                            print self.errorStart2[errorNo]+1, '>\t', self.file_org2[self.errorStart2[errorNo]]
                        self.errorStart2[errorNo] = self.errorStart2[errorNo] + 1
                        change = True
                    if change == True:
                        i = self.errorEnd2[errorNo]-1
                    else: 
                        print i+1, ' \t', self.file_org2[i]
                    errorNo = errorNo + 1
                else:
                    print i+1, ' \t', self.file_org2[i]
                i = i+1
        else:
            for i in range(len(self.errorStart1)):
                print '\n\t', self.errorStart1[i]+1, '-', self.errorEnd1[i], self.errorType[i], self.errorStart2[i]+1, '-', self.errorEnd2[i]
                if self.errorType[i] == 'd' or self.errorType[i] == 'c':
                    if self.errorStart1[i] > 0:
                        print self.errorStart1[i], ' \t', self.file_org1[self.errorStart1[i]-1]
                    while self.errorStart1[i] < self.errorEnd1[i]:
                        print self.errorStart1[i]+1, '<\t', self.file_org1[self.errorStart1[i]]
                        self.errorStart1[i] = self.errorStart1[i] + 1
                    if self.errorEnd1[i] < len(self.file_org1):
                        print self.errorEnd1[i]+1, ' \t', self.file_org1[self.errorEnd1[i]]
                print '--------'
                if self.errorType[i] == 'a' or self.errorType[i] == 'c':
                    if self.errorStart2[i] > 0:
                        print self.errorStart2[i], ' \t', self.file_org2[self.errorStart2[i]-1]
                    while self.errorStart2[i] < self.errorEnd2[i]:
                        print self.errorStart2[i]+1, '>\t', self.file_org2[self.errorStart2[i]]
                        self.errorStart2[i] = self.errorStart2[i] + 1
                    if self.errorEnd2[i] < len(self.file_org2):
                        print self.errorEnd2[i]+1, ' \t', self.file_org2[self.errorEnd2[i]]
                    

def main(argv):
    myDiffer = differ(argv)    # read arguments & files
    myDiffer.diff()            # calculate diff
    myDiffer.printDIFF()       # print diff

    
if __name__ == "__main__":
    main(sys.argv[1:])
    